##############################################################################
#    Copyright (C) 2001  MMmanager.org
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
##############################################################################
"""
"""

ADD_CONTENT_PERMISSION = 'Add portal content'

import Globals
import zLOG
import thread
from Products.CMFCore import CMFCorePermissions
from Products.CMFCore.CMFCorePermissions import View
from Products.CMFCore.CMFCorePermissions import ManageProperties
from AccessControl import ClassSecurityInfo, getSecurityManager
from Products.CMFCore.PortalContent import PortalContent
from Products.CMFDefault.DublinCore import DefaultDublinCoreImpl
from Products.CMFCore.utils import getToolByName

factory_type_information = {
      'id': 'ShopManager',
      'meta_type': 'MMM Shop Manager',
      'description': 'Use shop manager to manage your shop',
      'product': 'MMMShop',
      'icon': 'file_icon.gif',
      'factory': 'addShopManager',
      'filter_content_types': 0,
      'immediate_view': 'shopmanager_edit_form',
      'actions': 
	      ({'name': 'View',
	        'action': 'shopmanager_view',
		'permissions': ('View',),
		'category': 'object'},
	       {'name': 'Edit',
	        'action': 'shopmanager_edit_form',
		'permissions': ('Modify portal content',),
		'category': 'object'})
       }


class ShopManager(PortalContent
		, DefaultDublinCoreImpl
          	):
    """
        A Link
    """

    meta_type='MMM Shop Manager'
    portal_type='Object'
    effective_date = expiration_date = None
    _isDiscussable = 1
    httpsRoot = ''
    use_credit_details = 0
    shopid = ''
    shop_from_address = ''
    shop_from_name = ''
    send_fee_local = ''
    send_fee_world = ''
    exchange_fee = ''
    local_currency = ''
    
    security = ClassSecurityInfo()

    def __init__( self
                , id
                , title=''
                , description=''
                ):
        DefaultDublinCoreImpl.__init__(self)
        self.id=id
        self.title=title
	self.order_sequence = 0
	self.shop_from_name = ''
	self.shop_from_address = ''
	self.send_fee_local = ''
	self.send_fee_world = ''
	self.exchange_fee = ''
	self.local_currency = ''
    
    def SearchableText(self):
        """
            text for indexing
        """
        return "%s %s" % (self.title, self.description)

    security.declarePublic('editManager')
    def editManager(self, https_root=None, shopid=None, from_address=None, from_name=None, send_fee_local=None, send_fee_world=None, exchange_fee=None, local_currency=None):
	if https_root is not None:
	   self.httpsRoot = https_root

	if shopid is not None:
	   self.shopid = shopid

	if from_name is not None:
	   self.shop_from_name = from_name

	if from_address is not None:
	   self.shop_from_address = from_address

	if send_fee_local is not None:
	   self.send_fee_local = send_fee_local

	if send_fee_world is not None:
	   self.send_fee_world = send_fee_world

	if exchange_fee is not None:
	   self.exchange_fee = exchange_fee

	if local_currency is not None:
	   self.local_currency = local_currency

    security.declarePublic('create_order')
    def createOrder(self, REQUEST):
	
	credit_details = {}
	order_details = []
	personal_details = {}
	order_sequence = self.get_order_sequence()

	if self.use_credit_details and int(REQUEST['total_price']) > 0:
	   credit_details['creditNumber'] = REQUEST['creditNumber']
	   credit_details['expiryMonth'] = REQUEST['expiryMonth']
	   credit_details['expiryYear'] = REQUEST['expiryYear']
	   credit_details['creditType'] = REQUEST['creditType']

	user = str(getSecurityManager().getUser())
	membertool = getToolByName(self, 'portal_membership', None)
	if membertool is not None:
	   memberfolder = membertool.getHomeFolder(user)
	   if memberfolder is not None:
	      for item in memberfolder.objectValues('MMM Shop Shopping Cart'):
		  zLOG.LOG('ShopManager', 0, 'Item: %s' % (item))
		  obj = item
		 
	if obj is not None:
	   cart_items=obj.listProducts()
	   obj.setPersonalDetails(REQUEST['firstname'], REQUEST['lastname'], REQUEST['address'], REQUEST['postcode'], REQUEST['city'], REQUEST['phone'], REQUEST['email'])
	else:
	   raise 'ObjectError', 'Shopping Cart not assigned'

	for item in cart_items:
	   order_item = {}
	   order_item['product'] = item.getProduct()
	   order_item['quantity'] = item.getQuantity()
	   order_details.append(order_item)

    security.declarePublic('get_order_sequence')
    def get_order_sequence(self):
	self.order_sequence = self.order_sequence + 1
	return self.order_sequence - 1

    security.declarePublic('setOrderCount')
    def setOrderCount(self):
	self.order_sequence = self.order_sequence + 1


def addShopManager(self, id, title='', REQUEST=None):
	ob=ShopManager(id,title)
	self._setObject(id, ob)

Globals.InitializeClass(ShopManager)

from Products.CMFCore.register import registerPortalContent
registerPortalContent(ShopManager,
                      constructors=(addShopManager,),
		      action='shopmanager_edit_form',
		      icon='file_icon.gif')
